<?php
if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class Volunteer extends REF_Controller {
    public function __construct() {
        parent::__construct();
        $this->load->library('upload');
        $this->load->model('volunteer_model', '', TRUE);
        $this->uri_key_index = 0;
    }
    
    public function index() {
        $data = array();
        $data['results'] = $this->volunteer_model->list_all();
        if (!empty($this->session->flashdata('success'))) 
            $data['success'] = $this->session->flashdata('success');
        else 
            $data['error'] = $this->session->flashdata('error');
        
        $actions = $this->actions();
        $data['add_btn']    = 'Create New Volunteer';
        $data['view_link']  = $actions['view'] . '/';
        $data['add_link']   = $actions['add'];
        $data['edit_link']  = $actions['edit'] . '/';
        $data['delete_link']= $actions['delete'] . '/';
        
        $service_menu_id = get_master_controller_id($actions['controller']);
        $data['service_menu_id'] = array('service_menu_id' => $service_menu_id, 'menu_type' => '1');
        $this->render($data, 'volunteer/list');
    }
    
    private function get_volunteer_url_key($name, $id = '') {
        $url_key = get_url_key($name);
        if ($this->volunteer_model->volunteer_url_key_exists($url_key, $id)) {
            $this->uri_key_index ++;
            return $this->get_volunteer_url_key($name . '_' . $this->uri_key_index, $id);
        }
        
        return $url_key;
    }
    
    public function add() {
        $data = array();
        $actions = $this->actions();
        $data['form_action'] = $actions['insert'];
        $this->render($data, 'volunteer/add');
    }
    
    public function insert() {
        $insert = array(
            'name' => $this->input->post('name'),
            'phone' => $this->input->post('phone_no'),
            'email'=> $this->input->post('email'),
            /* 'website' => $this->input->post('website'),
            'fax' => $this->input->post('fax'),
            'unit_no' => $this->input->post('unit_no'),
            'blk' => $this->input->post('blk'), */
            'address' => $this->input->post('address'),
            'url_key' => $this->get_volunteer_url_key($this->input->post('name')),
            'status' => $this->input->post('status'),
            'created_by' => $this->user_data['user_id'],
            'created_on' => date('Y-m-d H:i:s')
        );
        
        // Upload Photo
        $upload = $this->upload(VOL_DIR);
        $insert['image'] = $upload['file_name'];
        
        
        $insert_id = $this->volunteer_model->insert($insert);  
        if ($insert_id > 0)
            $this->session->set_flashdata('success', 'Volunteer added successfully');    
        
        else
            $this->session->set_flashdata('error', 'Volunteer not added!');
        redirect('volunteer', 'refresh');
    }
    
    public function edit($id = '') {
        if (empty($id)) {
            show_400_error();
        }
        
        $data = array();
        $data['volunteer'] = $this->volunteer_model->get_by_id($id);
        $actions = $this->actions();
        $data['form_action'] = $actions['update'] . '/' . $id;
        $this->render($data, 'volunteer/edit');
    }
    
    public function update($id = '') {
        if (empty($id)) {
            show_400_error();
        }
        
        $update = array(
            'name' => $this->input->post('name'),
            'phone' => $this->input->post('phone_no'),
            'email'=> $this->input->post('email'),
            /* 'website' => $this->input->post('website'),
            'fax' => $this->input->post('fax'),
            'unit_no' => $this->input->post('unit_no'),
            'blk' => $this->input->post('blk'), */
            'address' => $this->input->post('address'),
            'url_key' => $this->get_volunteer_url_key($this->input->post('name')),
            'status' => $this->input->post('status'),
            'updated_by' => $this->user_data['user_id'],
            'updated_on' => date('Y-m-d H:i:s')
        );
        
        // Upload Photo
        $upload = $this->upload(VOL_DIR);
        if( !empty( $upload['file_name'] ) ) :
            // New Photo
            $update['image'] = $upload['file_name'];
        
            $prev_img = $this->input->post('prev-image');    
            if( !empty( $prev_img ) ) :
                unlink( VOL_DIR . $prev_img );
            endif;
        endif;
            
        if( !empty( $this->input->post('rm-image') ) ) :
            // Remove Image
            $update['image'] = null; 
            unlink( VOL_DIR . $this->input->post('rm-image') );
        endif;
       
        if ( $this->volunteer_model->update($update, $id) > 0)
            $this->session->set_flashdata('success', 'Volunteer updated successfully');  
       
        else
            $this->session->set_flashdata('error', 'Volunteer not updated!');    
        
        redirect('volunteer','refresh');
    }
    
    function upload( $path = '', $field = 'image' ) {
        $file = $_FILES[$field];
        $path = !empty( $path ) ? $path : UPLOADS;
        if( empty( $file['name'] ) ) :
            return '';
        endif;
        
        // Load upload library
        if( empty( $this->upload ) ) :
            $this->load->library( 'upload' );
        endif;
        
        $config = array(
            'file_name'     => time().'_'.$file['name'],
            'upload_path'   => $path,
            'allowed_types' => 'png|jpg|bmp|jpeg|ico',
            
        );
        
        if( !file_exists( $config['upload_path'] ) ) :
            mkdir( $config['upload_path'], 0777 );
        endif;
        
        $this->upload->initialize( $config );
        $this->upload->do_upload( $field );
        
        return $this->upload->data();
        
    }
    
    public function view($id = '') {
        if (empty($id)) {
            show_400_error();
        }
        
        $data = array();
        $data['volunteer'] = $this->volunteer_model->get_by_id($id);
        $this->render($data, 'volunteer/view');
    }
    
    public function delete($id = '') {
        if (empty($id)) {
            show_400_error();
        }
        
        $update = array ( 
            'status' => 2,
            'updated_by' => $this->user_data['user_id'],
            'updated_on' => date('Y-m-d H:i:s')
        );
        
        if ($this->volunteer_model->update($update,$id) > 0)
            $this->session->set_flashdata('success', 'Volunteer deleted successfully');
            
        else 
            $this->session->set_flashdata('error', 'Volunteer not deleted!');
        
        redirect( 'volunteer', 'refresh');
    }
}
?>